# include <stdio.h>
# include <math.h>

/*************************************************************/
/* Deklaration der Funktion trapez_regel()                   */
/* Eingabeparameter : 1.) Zeiger auf Funktion mit 
 *                        Eingabeparameter double-Wert  
 *                        und double-R\"uckgabewert
 *                    2.) double f\"ur linke Intervallgrenze
 *                    3.) double f\"ur rechte Intervallgrenze
 *                    4.) int f\"ur Anzahl der St\"utzstellen    
 * R\"uckgabewert : double f\"ur das Integral
**************************************************************/
double trapez_regel(double (*f)(double ),double ,double ,int );

/************************************************************************/
/* Hauptprogramm                                                        */
/************************************************************************/
int main(int argc,char** argv)
{
	int n;
	double a,b,integral;

	/* Zeiger auf eine Funktion die als R\"uckgabewert
	 * eine double-Variable besitzt und als 
	 * Eingabe eine double-Variable verlangt         */
	double (*fptr)(double); 

	if (argc<4)
	{
		printf("Programm ben\"otigt 3 Kommandozeilenparameter :\n");
		printf("1.) Linker Intervallrand (double)\n");
		printf("2.) Rechter Intervallrand (double)\n");
		printf("3.) Anzahl der Teilintervalle f\"ur");
		printf(" numerische Integration (int)\n");

		return 1;
	}
	else
	{
		sscanf(argv[1],"%lf",&a);
		sscanf(argv[2],"%lf",&b);
		sscanf(argv[3],"%i",&n);
	

		fptr=(double(*)(double)) cos;/* Zeiger fptr auf cos-Funktion */
		integral=trapez_regel(fptr,a,b,n);
		printf("Das Integral der cos-Funktion \"uber das Intervall");
		printf(" [%f , %f]\n",a,b);
		printf("betr\"agt : \t %f (numerisch mit %i",integral,n+1);
		printf(" St\"utzstellen)\n");
		printf("          \t %f (exakt)\n\n",sin(b)-sin(a));

		fptr=(double (*)(double)) sin;/*Zeiger fptr auf sin-Funktion */
		integral=trapez_regel(fptr,a,b,n);
		printf("Das Integral der sin-Funktion \"uber das Intervall");
		printf(" [%f , %f]\n",a,b);
		printf("betr\"agt : \t %f (numerisch mit %i",integral,n+1);
		printf(" St\"utzstellen)\n");
		printf("          \t %f (exakt)\n\n",cos(a)-cos(b));

		return 0;
	}
}

/*******************************************************************/
/* Definition der Funktion trapez_regel()                          */
/*******************************************************************/
double trapez_regel(double (*f)(double ),double a,double b,int n)
{
	n=n+1;
	int k;
	double h=(b-a)/n;
	double integral=0;

	for (k=0;k<=n-1;k++) integral=integral+h/2*(f(a+k*h)+f(a+(k+1)*h));
	
	return integral;
}



